home *** CD-ROM | disk | FTP | other *** search
/ PC World Komputer 2010 April / PCWorld0410.iso / hity wydania / Ubuntu 9.10 PL / karmelkowy-koliberek-desktop-9.10-i386-PL.iso / casper / filesystem.squashfs / var / lib / dpkg / info / xfonts-100dpi.postinst < prev    next >
Text File  |  2009-05-11  |  31KB  |  935 lines

  1. #!/bin/sh
  2. # Debian xfonts-100dpi package post-installation script
  3. # Copyright 1998-2001 Branden Robinson.
  4. # Licensed under the GNU General Public License, version 2.  See the file
  5. # /usr/share/common-licenses/GPL or <http://www.gnu.org/copyleft/gpl.txt>.
  6. # Acknowledgements to Stephen Early, Mark Eichin, and Manoj Srivastava.
  7.  
  8. # $Id: xfonts-100dpi.postinst.in 189 2005-06-11 00:04:27Z branden $
  9.  
  10. set -e
  11.  
  12. THIS_PACKAGE=xfonts-100dpi
  13. THIS_SCRIPT=postinst
  14.  
  15. # $Id$
  16.  
  17. # This is the X Strike Force shell library for X Window System package
  18. # maintainer scripts.  It serves to define shell functions commonly used by
  19. # such packages, and performs some error checking necessary for proper operation
  20. # of those functions.  By itself, it does not "do" much; the maintainer scripts
  21. # invoke the functions defined here to accomplish package installation and
  22. # removal tasks.
  23.  
  24. # If you are reading this within a Debian package maintainer script (e.g.,
  25. # /var/lib/dpkg)info/PACKAGE.{config,preinst,postinst,prerm,postrm}), you can
  26. # skip past this library by scanning forward in this file to the string
  27. # "GOBSTOPPER".
  28.  
  29. SOURCE_VERSION=1:1.0.0-4build1
  30. OFFICIAL_BUILD=
  31.  
  32. # Use special abnormal exit codes so that problems with this library are more
  33. # easily tracked down.
  34. SHELL_LIB_INTERNAL_ERROR=86
  35. SHELL_LIB_THROWN_ERROR=74
  36. SHELL_LIB_USAGE_ERROR=99
  37.  
  38. # old -> new variable names
  39. if [ -z "$DEBUG_XORG_PACKAGE" ] && [ -n "$DEBUG_XFREE86_PACKAGE" ]; then
  40.   DEBUG_XORG_PACKAGE="$DEBUG_XFREE86_PACKAGE"
  41. fi
  42. if [ -z "$DEBUG_XORG_DEBCONF" ] && [ -n "$DEBUG_XFREE86_DEBCONF" ]; then
  43.   DEBUG_XORG_DEBCONF="$DEBUG_XFREE86_DEBCONF"
  44. fi
  45.  
  46. # initial sanity checks
  47. if [ -z "$THIS_PACKAGE" ]; then
  48.   cat >&2 <<EOF
  49. Error: package maintainer script attempted to use shell library without
  50. definining \$THIS_PACKAGE shell variable.  Please report the package name,
  51. version, and the text of this error message to the Debian Bug Tracking System.
  52. Visit <http://www.debian.org/Bugs/Reporting> on the World Wide Web for
  53. instructions, read the file /usr/share/doc/debian/bug-reporting.txt from the
  54. "doc-debian" package, or install the "reportbug" package and use the command of
  55. the same name to file a report against version $SOURCE_VERSION of this package.
  56. EOF
  57.   exit $SHELL_LIB_USAGE_ERROR
  58. fi
  59.  
  60. if [ -z "$THIS_SCRIPT" ]; then
  61.   cat >&2 <<EOF
  62. Error: package maintainer script attempted to use shell library without
  63. definining \$THIS_SCRIPT shell variable.  Please report the package name,
  64. version, and the text of this error message to the Debian Bug Tracking System.
  65. Visit <http://www.debian.org/Bugs/Reporting> on the World Wide Web for
  66. instructions, read the file /usr/share/doc/debian/bug-reporting.txt from the
  67. "doc-debian" package, or install the "reportbug" package and use the command of
  68. the same name to file a report against version $SOURCE_VERSION of the
  69. "$THIS_PACKAGE" package.
  70. EOF
  71.   exit $SHELL_LIB_USAGE_ERROR
  72. fi
  73.  
  74. ARCHITECTURE="$(dpkg --print-installation-architecture)"
  75.  
  76. LAPTOP=""
  77. if [ -n "$(which laptop-detect)" ]; then
  78.     if laptop-detect >/dev/null; then
  79.     LAPTOP=true
  80.     fi
  81. fi
  82.  
  83. if [ "$1" = "reconfigure" ] || [ -n "$DEBCONF_RECONFIGURE" ]; then
  84.   RECONFIGURE="true"
  85. else
  86.   RECONFIGURE=
  87. fi
  88.  
  89. if ([ "$1" = "install" ] || [ "$1" = "configure" ]) && [ -z "$2" ]; then
  90.   FIRSTINST="yes"
  91. fi
  92.  
  93. if [ -z "$RECONFIGURE" ] && [ -z "$FIRSTINST" ]; then
  94.   UPGRADE="yes"
  95. fi
  96.  
  97. trap "message;\
  98.       message \"Received signal.  Aborting $THIS_PACKAGE package $THIS_SCRIPT script.\";\
  99.       message;\
  100.       exit 1" HUP INT QUIT TERM
  101.  
  102. reject_nondigits () {
  103.   # syntax: reject_nondigits [ operand ... ]
  104.   #
  105.   # scan operands (typically shell variables whose values cannot be trusted) for
  106.   # characters other than decimal digits and barf if any are found
  107.   while [ -n "$1" ]; do
  108.     # does the operand contain anything but digits?
  109.     if ! expr "$1" : "[[:digit:]]\+$" > /dev/null 2>&1; then
  110.       # can't use die(), because it wraps message() which wraps this function
  111.       echo "$THIS_PACKAGE $THIS_SCRIPT error: reject_nondigits() encountered" \
  112.            "possibly malicious garbage \"$1\"" >&2
  113.       exit $SHELL_LIB_THROWN_ERROR
  114.     fi
  115.     shift
  116.   done
  117. }
  118.  
  119. reject_whitespace () {
  120.   # syntax: reject_whitespace [ operand ]
  121.   #
  122.   # scan operand (typically a shell variable whose value cannot be trusted) for
  123.   # whitespace characters and barf if any are found
  124.   if [ -n "$1" ]; then
  125.     # does the operand contain any whitespace?
  126.     if expr "$1" : "[[:space:]]" > /dev/null 2>&1; then
  127.       # can't use die(), because I want to avoid forward references
  128.       echo "$THIS_PACKAGE $THIS_SCRIPT error: reject_whitespace() encountered" \
  129.            "possibly malicious garbage \"$1\"" >&2
  130.       exit $SHELL_LIB_THROWN_ERROR
  131.     fi
  132.   fi
  133. }
  134.  
  135. reject_unlikely_path_chars () {
  136.   # syntax: reject_unlikely_path_chars [ operand ... ]
  137.   #
  138.   # scan operands (typically shell variables whose values cannot be trusted) for
  139.   # characters unlikely to be seen in a path and which the shell might
  140.   # interpret and barf if any are found
  141.   while [ -n "$1" ]; do
  142.     # does the operand contain any funny characters?
  143.     if expr "$1" : '.*[!$&()*;<>?|].*' > /dev/null 2>&1; then
  144.       # can't use die(), because I want to avoid forward references
  145.       echo "$THIS_PACKAGE $THIS_SCRIPT error: reject_unlikely_path_chars()" \
  146.            "encountered possibly malicious garbage \"$1\"" >&2
  147.       exit $SHELL_LIB_THROWN_ERROR
  148.     fi
  149.     shift
  150.   done
  151. }
  152.  
  153. # Query the terminal to establish a default number of columns to use for
  154. # displaying messages to the user.  This is used only as a fallback in the
  155. # event the COLUMNS variable is not set.  ($COLUMNS can react to SIGWINCH while
  156. # the script is running, and this cannot, only being calculated once.)
  157. DEFCOLUMNS=$(stty size 2> /dev/null | awk '{print $2}') || true
  158. if ! expr "$DEFCOLUMNS" : "[[:digit:]]\+$" > /dev/null 2>&1; then
  159.   DEFCOLUMNS=80
  160. fi
  161.  
  162. message () {
  163.   # pretty-print messages of arbitrary length
  164.   reject_nondigits "$COLUMNS"
  165.   echo "$*" | fmt -t -w ${COLUMNS:-$DEFCOLUMNS} >&2
  166. }
  167.  
  168. observe () {
  169.   # syntax: observe message ...
  170.   #
  171.   # issue observational message suitable for logging someday when support for
  172.   # it exists in dpkg
  173.   if [ -n "$DEBUG_XORG_PACKAGE" ]; then
  174.     message "$THIS_PACKAGE $THIS_SCRIPT note: $*"
  175.   fi
  176. }
  177.  
  178. warn () {
  179.   # syntax: warn message ...
  180.   #
  181.   # issue warning message suitable for logging someday when support for
  182.   # it exists in dpkg; also send to standard error
  183.   message "$THIS_PACKAGE $THIS_SCRIPT warning: $*"
  184. }
  185.  
  186. die () {
  187.   # syntax: die message ...
  188.   #
  189.   # exit script with error message
  190.   message "$THIS_PACKAGE $THIS_SCRIPT error: $*"
  191.   exit $SHELL_LIB_THROWN_ERROR
  192. }
  193.  
  194. internal_error () {
  195.   # exit script with error; essentially a "THIS SHOULD NEVER HAPPEN" message
  196.   message "internal error: $*"
  197.   if [ -n "$OFFICIAL_BUILD" ]; then
  198.     message "Please report a bug in the $THIS_SCRIPT script of the" \
  199.             "$THIS_PACKAGE package, version $SOURCE_VERSION to the Debian Bug" \
  200.             "Tracking System.  Include all messages above that mention the" \
  201.             "$THIS_PACKAGE package.  Visit " \
  202.             "<http://www.debian.org/Bugs/Reporting> on the World Wide Web for" \
  203.             "instructions, read the file" \
  204.             "/usr/share/doc/debian/bug-reporting.txt from the doc-debian" \
  205.             "package, or install the reportbug package and use the command of" \
  206.             "the same name to file a report."
  207.   fi
  208.   exit $SHELL_LIB_INTERNAL_ERROR
  209. }
  210.  
  211. usage_error () {
  212.   message "usage error: $*"
  213.   message "Please report a bug in the $THIS_SCRIPT script of the" \
  214.           "$THIS_PACKAGE package, version $SOURCE_VERSION to the Debian Bug" \
  215.           "Tracking System.  Include all messages above that mention the" \
  216.           "$THIS_PACKAGE package.  Visit " \
  217.           "<http://www.debian.org/Bugs/Reporting> on the World Wide Web for" \
  218.           "instructions, read the file" \
  219.           "/usr/share/doc/debian/bug-reporting.txt from the doc-debian" \
  220.           "package, or install the reportbug package and use the command of" \
  221.           "the same name to file a report."
  222.   exit $SHELL_LIB_USAGE_ERROR
  223. }
  224.  
  225.  
  226. maplink () {
  227.   # returns what symlink should point to; i.e., what the "sane" answer is
  228.   # Keep this in sync with the debian/*.links files.
  229.   # This is only needed for symlinks to directories.
  230.   #
  231.   # XXX: Most of these look wrong in the X11R7 world and need to be fixed.
  232.   # If we've stopped using this function, fixing it might enable us to re-enable
  233.   # it again and catch more errors.
  234.   case "$1" in
  235.     /etc/X11/xkb/compiled) echo /var/lib/xkb ;;
  236.     /etc/X11/xkb/xkbcomp) echo /usr/X11R6/bin/xkbcomp ;;
  237.     /usr/X11R6/lib/X11/app-defaults) echo /etc/X11/app-defaults ;;
  238.     /usr/X11R6/lib/X11/fs) echo /etc/X11/fs ;;
  239.     /usr/X11R6/lib/X11/lbxproxy) echo /etc/X11/lbxproxy ;;
  240.     /usr/X11R6/lib/X11/proxymngr) echo /etc/X11/proxymngr ;;
  241.     /usr/X11R6/lib/X11/rstart) echo /etc/X11/rstart ;;
  242.     /usr/X11R6/lib/X11/twm) echo /etc/X11/twm ;;
  243.     /usr/X11R6/lib/X11/xdm) echo /etc/X11/xdm ;;
  244.     /usr/X11R6/lib/X11/xinit) echo /etc/X11/xinit ;;
  245.     /usr/X11R6/lib/X11/xkb) echo /etc/X11/xkb ;;
  246.     /usr/X11R6/lib/X11/xserver) echo /etc/X11/xserver ;;
  247.     /usr/X11R6/lib/X11/xsm) echo /etc/X11/xsm ;;
  248.     /usr/bin/X11) echo ../X11R6/bin ;;
  249.     /usr/bin/rstartd) echo ../X11R6/bin/rstartd ;;
  250.     /usr/include/X11) echo ../X11R6/include/X11 ;;
  251.     /usr/lib/X11) echo ../X11R6/lib/X11 ;;
  252.     *) internal_error "maplink() called with unknown path \"$1\"" ;;
  253.   esac
  254. }
  255.  
  256. analyze_path () {
  257.   # given a supplied set of pathnames, break each one up by directory and do an
  258.   # ls -dl on each component, cumulatively; i.e.
  259.   # analyze_path /usr/X11R6/bin -> ls -dl /usr /usr/X11R6 /usr/X11R6/bin
  260.   # Thanks to Randolph Chung for this clever hack.
  261.  
  262.   #local f g
  263.  
  264.   while [ -n "$1" ]; do
  265.     reject_whitespace "$1"
  266.     _g=
  267.     message "Analyzing $1:"
  268.     for _f in $(echo "$1" | tr / \  ); do
  269.       if [ -e /$_g$_f ]; then
  270.         ls -dl /$_g$_f /$_g$_f.dpkg-* 2> /dev/null || true
  271.         _g=$_g$_f/
  272.       else
  273.         message "/$_g$_f: nonexistent; directory contents of /$_g:"
  274.         ls -l /$_g
  275.         break
  276.       fi
  277.     done
  278.     shift
  279.   done
  280. }
  281.  
  282. find_culprits () {
  283.   #local f p dpkg_info_dir possible_culprits smoking_guns bad_packages package \
  284.   #  msg
  285.  
  286.   reject_whitespace "$1"
  287.   message "Searching for overlapping packages..."
  288.   _dpkg_info_dir=/var/lib/dpkg/info
  289.   if [ -d $_dpkg_info_dir ]; then
  290.     if [ "$(echo $_dpkg_info_dir/*.list)" != "$_dpkg_info_dir/*.list" ]; then
  291.       _possible_culprits=$(ls -1 $_dpkg_info_dir/*.list | egrep -v \
  292.         "(xbase-clients|x11-common|xfs|xlibs)")
  293.       if [ -n "$_possible_culprits" ]; then
  294.         _smoking_guns=$(grep -l "$1" $_possible_culprits || true)
  295.         if [ -n "$_smoking_guns" ]; then
  296.           _bad_packages=$(printf "\\n")
  297.           for f in $_smoking_guns; do
  298.             # too bad you can't nest parameter expansion voodoo
  299.             p=${f%*.list}      # strip off the trailing ".list"
  300.             _package=${p##*/}   # strip off the directories
  301.             _bad_packages=$(printf "%s\n%s" "$_bad_packages" "$_package")
  302.           done
  303.           _msg=$(cat <<EOF
  304. The following packages appear to have file overlaps with the X.Org packages;
  305. these packages are either very old, or in violation of Debian Policy.  Try
  306. upgrading each of these packages to the latest available version if possible:
  307. for example, with the command "apt-get install".  If no newer version of a
  308. package is available, you will have to remove it; for example, with the command
  309. "apt-get remove".  If even the latest available version of the package has
  310. this file overlap, please file a bug against that package with the Debian Bug
  311. Tracking System.  You may want to refer the package maintainer to section 12.8
  312. of the Debian Policy manual.
  313. EOF
  314. )
  315.           message "$_msg"
  316.           message "The overlapping packages are: $_bad_packages"
  317.         else
  318.           message "no overlaps found."
  319.         fi
  320.       fi
  321.     else
  322.       message "cannot search; no matches for $_dpkg_info_dir/*.list."
  323.     fi
  324.   else
  325.     message "cannot search; $_dpkg_info_dir does not exist."
  326.   fi
  327. }
  328.  
  329. # we require a readlink command or shell function
  330. if ! which readlink > /dev/null 2>&1; then
  331.   message "The readlink command was not found.  Please install version" \
  332.           "1.13.1 or later of the debianutils package."
  333.   readlink () {
  334.     # returns what symlink in $1 actually points to
  335.     perl -e '$l = shift; exit 1 unless -l $l; $r = readlink $l; exit 1 unless $r; print "$r\n"' "$1"
  336.   }
  337. fi
  338.  
  339. check_symlink () {
  340.   # syntax: check_symlink symlink
  341.   #
  342.   # See if specified symlink points where it is supposed to.  Return 0 if it
  343.   # does, and 1 if it does not.
  344.   #
  345.   # Primarily used by check_symlinks_and_warn() and check_symlinks_and_bomb().
  346.  
  347.   #local symlink
  348.  
  349.   # validate arguments
  350.   if [ $# -ne 1 ]; then
  351.     usage_error "check_symlink() called with wrong number of arguments;" \
  352.                 "expected 1, got $#"
  353.     exit $SHELL_LIB_USAGE_ERROR
  354.   fi
  355.  
  356.   _symlink="$1"
  357.  
  358.   if [ "$(maplink "$_symlink")" = "$(readlink "$_symlink")" ]; then
  359.     return 0
  360.   else
  361.     return 1
  362.   fi
  363. }
  364.  
  365. check_symlinks_and_warn () {
  366.   # syntax: check_symlinks_and_warn symlink ...
  367.   #
  368.   # For each argument, check for symlink sanity, and warn if it isn't sane.
  369.   #
  370.   # Call this function from a preinst script in the event $1 is "upgrade" or
  371.   # "install".
  372.  
  373.   #local errmsg symlink
  374.  
  375.   # validate arguments
  376.   if [ $# -lt 1 ]; then
  377.     usage_error "check_symlinks_and_warn() called with wrong number of" \
  378.                 "arguments; expected at least 1, got $#"
  379.     exit $SHELL_LIB_USAGE_ERROR
  380.   fi
  381.  
  382.   while [ -n "$1" ]; do
  383.     _symlink="$1"
  384.     if [ -L "$_symlink" ]; then
  385.       if ! check_symlink "$_symlink"; then
  386.         observe "$_symlink symbolic link points to wrong location" \
  387.                 "$(readlink "$_symlink"); removing"
  388.         rm "$_symlink"
  389.       fi
  390.     elif [ -e "$_symlink" ]; then
  391.       _errmsg="$_symlink exists and is not a symbolic link; this package cannot"
  392.       _errmsg="$_errmsg be installed until this"
  393.       if [ -f "$_symlink" ]; then
  394.         _errmsg="$_errmsg file"
  395.       elif [ -d "$_symlink" ]; then
  396.         _errmsg="$_errmsg directory"
  397.       else
  398.         _errmsg="$_errmsg thing"
  399.       fi
  400.       _errmsg="$_errmsg is removed"
  401.       die "$_errmsg"
  402.     fi
  403.     shift
  404.   done
  405. }
  406.  
  407. check_symlinks_and_bomb () {
  408.   # syntax: check_symlinks_and_bomb symlink ...
  409.   #
  410.   # For each argument, check for symlink sanity, and bomb if it isn't sane.
  411.   #
  412.   # Call this function from a postinst script.
  413.  
  414.   #local problem symlink
  415.  
  416.   # validate arguments
  417.   if [ $# -lt 1 ]; then
  418.     usage_error "check_symlinks_and_bomb() called with wrong number of"
  419.                 "arguments; expected at least 1, got $#"
  420.     exit $SHELL_LIB_USAGE_ERROR
  421.   fi
  422.  
  423.   while [ -n "$1" ]; do
  424.     _problem=
  425.     _symlink="$1"
  426.     if [ -L "$_symlink" ]; then
  427.       if ! check_symlink "$_symlink"; then
  428.         _problem=yes
  429.         warn "$_symlink symbolic link points to wrong location" \
  430.              "$(readlink "$_symlink")"
  431.       fi
  432.     elif [ -e "$_symlink" ]; then
  433.       _problem=yes
  434.       warn "$_symlink is not a symbolic link"
  435.     else
  436.       _problem=yes
  437.       warn "$_symlink symbolic link does not exist"
  438.     fi
  439.     if [ -n "$_problem" ]; then
  440.       analyze_path "$_symlink" "$(readlink "$_symlink")"
  441.       find_culprits "$_symlink"
  442.       die "bad symbolic links on system"
  443.     fi
  444.     shift
  445.   done
  446. }
  447.  
  448. font_update () {
  449.   # run $UPDATECMDS in $FONTDIRS
  450.  
  451.   #local dir cmd shortcmd x_font_dir_prefix
  452.  
  453.   _x_font_dir_prefix="/usr/share/fonts/X11"
  454.  
  455.   if [ -z "$UPDATECMDS" ]; then
  456.     usage_error "font_update() called but \$UPDATECMDS not set"
  457.   fi
  458.   if [ -z "$FONTDIRS" ]; then
  459.     usage_error "font_update() called but \$FONTDIRS not set"
  460.   fi
  461.  
  462.   reject_unlikely_path_chars "$UPDATECMDS"
  463.   reject_unlikely_path_chars "$FONTDIRS"
  464.  
  465.   for _dir in $FONTDIRS; do
  466.     if [ -d "$_x_font_dir_prefix/$_dir" ]; then
  467.       for _cmd in $UPDATECMDS; do
  468.         if which "$_cmd" > /dev/null 2>&1; then
  469.           _shortcmd=${_cmd##*/}
  470.           observe "running $_shortcmd in $_dir font directory"
  471.       _cmd_opts=
  472.           if [ "$_shortcmd" = "update-fonts-alias" ]; then
  473.             _cmd_opts=--x11r7-layout
  474.           fi
  475.           if [ "$_shortcmd" = "update-fonts-dir" ]; then
  476.             _cmd_opts=--x11r7-layout
  477.           fi
  478.           if [ "$_shortcmd" = "update-fonts-scale" ]; then
  479.             _cmd_opts=--x11r7-layout
  480.           fi
  481.           $_cmd $_cmd_opts $_dir || warn "$_cmd $_cmd_opts $_dir" \
  482.                               "failed; font directory data may not" \
  483.                               "be up to date"
  484.         else
  485.           warn "$_cmd not found; not updating corresponding $_dir font" \
  486.                "directory data"
  487.         fi
  488.       done
  489.     else
  490.       warn "$_dir is not a directory; not updating font directory data"
  491.     fi
  492.   done
  493. }
  494.  
  495. remove_conffile_prepare () {
  496.   # syntax: remove_conffile_prepare filename official_md5sum ...
  497.   #
  498.   # Check a conffile "filename" against a list of canonical MD5 checksums.
  499.   # If the file's current MD5 checksum matches one of the "official_md5sum"
  500.   # operands provided, then prepare the conffile for removal from the system.
  501.   # We defer actual deletion until the package is configured so that we can
  502.   # roll this operation back if package installation fails.
  503.   #
  504.   # Call this function from a preinst script in the event $1 is "upgrade" or
  505.   # "install" and verify $2 to ensure the package is being upgraded from a
  506.   # version (or installed over a version removed-but-not-purged) prior to the
  507.   # one in which the conffile was obsoleted.
  508.  
  509.   #local conffile current_checksum
  510.  
  511.   # validate arguments
  512.   if [ $# -lt 2 ]; then
  513.     usage_error "remove_conffile_prepare() called with wrong number of" \
  514.                 "arguments; expected at least 2, got $#"
  515.     exit $SHELL_LIB_USAGE_ERROR
  516.   fi
  517.  
  518.   _conffile="$1"
  519.   shift
  520.  
  521.   # does the _conffile even exist?
  522.   if [ -e "$_conffile" ]; then
  523.     # calculate its checksum
  524.     _current_checksum=$(md5sum < "$_conffile" | sed 's/[[:space:]].*//')
  525.     # compare it to each supplied checksum
  526.     while [ -n "$1" ]; do
  527.       if [ "$_current_checksum" = "$1" ]; then
  528.         # we found a match; move the confffile and stop looking
  529.         observe "preparing obsolete conffile $_conffile for removal"
  530.         mv "$_conffile" "$_conffile.$THIS_PACKAGE-tmp"
  531.         break
  532.       fi
  533.       shift
  534.     done
  535.   fi
  536. }
  537.  
  538. remove_conffile_commit () {
  539.   # syntax: remove_conffile_commit filename
  540.   #
  541.   # Complete the removal of a conffile "filename" that has become obsolete.
  542.   #
  543.   # Call this function from a postinst script after having used
  544.   # remove_conffile_prepare() in the preinst.
  545.  
  546.   #local conffile
  547.  
  548.   # validate arguments
  549.   if [ $# -ne 1 ]; then
  550.     usage_error "remove_conffile_commit() called with wrong number of" \
  551.                 "arguments; expected 1, got $#"
  552.     exit $SHELL_LIB_USAGE_ERROR
  553.   fi
  554.  
  555.   _conffile="$1"
  556.  
  557.   # if the temporary file created by remove_conffile_prepare() exists, remove it
  558.   if [ -e "$_conffile.$THIS_PACKAGE-tmp" ]; then
  559.     observe "committing removal of obsolete conffile $_conffile"
  560.     rm "$_conffile.$THIS_PACKAGE-tmp"
  561.   fi
  562. }
  563.  
  564. remove_conffile_rollback () {
  565.   # syntax: remove_conffile_rollback filename
  566.   #
  567.   # Roll back the removal of a conffile "filename".
  568.   #
  569.   # Call this function from a postrm script in the event $1 is "abort-upgrade"
  570.   # or "abort-install" is  after having used remove_conffile_prepare() in the
  571.   # preinst.
  572.  
  573.   #local conffile
  574.  
  575.   # validate arguments
  576.   if [ $# -ne 1 ]; then
  577.     usage_error "remove_conffile_rollback() called with wrong number of" \
  578.                 "arguments; expected 1, got $#"
  579.     exit $SHELL_LIB_USAGE_ERROR
  580.   fi
  581.  
  582.   _conffile="$1"
  583.  
  584.   # if the temporary file created by remove_conffile_prepare() exists, move it
  585.   # back
  586.   if [ -e "$_conffile.$THIS_PACKAGE-tmp" ]; then
  587.     observe "rolling back removal of obsolete conffile $_conffile"
  588.     mv "$_conffile.$THIS_PACKAGE-tmp" "$_conffile"
  589.   fi
  590. }
  591.  
  592. replace_conffile_with_symlink_prepare () {
  593.   # syntax: replace_conffile_with_symlink_prepare oldfilename newfilename \
  594.   # official_md5sum ...
  595.   #
  596.   # Check a conffile "oldfilename" against a list of canonical MD5 checksums.
  597.   # If the file's current MD5 checksum matches one of the "official_md5sum"
  598.   # operands provided, then prepare the conffile for removal from the system.
  599.   # We defer actual deletion until the package is configured so that we can
  600.   # roll this operation back if package installation fails. Otherwise copy it
  601.   # to newfilename and let dpkg handle it through conffiles mechanism.
  602.   #
  603.   # Call this function from a preinst script in the event $1 is "upgrade" or
  604.   # "install" and verify $2 to ensure the package is being upgraded from a
  605.   # version (or installed over a version removed-but-not-purged) prior to the
  606.   # one in which the conffile was obsoleted.
  607.  
  608.   #local conffile current_checksum
  609.  
  610.   # validate arguments
  611.   if [ $# -lt 3 ]; then
  612.     usage_error "replace_conffile_with_symlink_prepare() called with wrong" \
  613.                 " number of arguments; expected at least 3, got $#"
  614.     exit $SHELL_LIB_USAGE_ERROR
  615.   fi
  616.  
  617.   _oldconffile="$1"
  618.   shift
  619.   _newconffile="$1"
  620.   shift
  621.  
  622.   remove_conffile_prepare "$_oldconffile" "$@"
  623.   # If $_oldconffile still exists, then md5sums didn't match.
  624.   # Copy it to new one.
  625.   if [ -f "$_oldconffile" ]; then
  626.     cp "$_oldconffile" "$_newconffile"
  627.   fi
  628.  
  629. }
  630.  
  631. replace_conffile_with_symlink_commit () {
  632.   # syntax: replace_conffile_with_symlink_commit oldfilename
  633.   #
  634.   # Complete the removal of a conffile "oldfilename" that has been
  635.   # replaced by a symlink.
  636.   #
  637.   # Call this function from a postinst script after having used
  638.   # replace_conffile_with_symlink_prepare() in the preinst.
  639.  
  640.   #local conffile
  641.  
  642.   # validate arguments
  643.   if [ $# -ne 1 ]; then
  644.     usage_error "replace_conffile_with_symlink_commit() called with wrong" \
  645.                 "number of arguments; expected 1, got $#"
  646.     exit $SHELL_LIB_USAGE_ERROR
  647.   fi
  648.  
  649.   _conffile="$1"
  650.  
  651.   remove_conffile_commit "$_conffile"
  652. }
  653.  
  654. replace_conffile_with_symlink_rollback () {
  655.   # syntax: replace_conffile_with_symlink_rollback oldfilename newfilename
  656.   #
  657.   # Roll back the replacing of a conffile "oldfilename" with symlink to
  658.   # "newfilename".
  659.   #
  660.   # Call this function from a postrm script in the event $1 is "abort-upgrade"
  661.   # or "abort-install" and verify $2 to ensure the package failed to upgrade
  662.   # from a version (or install over a version removed-but-not-purged) prior
  663.   # to the one in which the conffile was obsoleted.
  664.   # You should have  used replace_conffile_with_symlink_prepare() in the
  665.   # preinst.
  666.  
  667.   #local conffile
  668.  
  669.   # validate arguments
  670.   if [ $# -ne 2 ]; then
  671.     usage_error "replace_conffile_with_symlink_rollback() called with wrong" \
  672.                 "number of arguments; expected 2, got $#"
  673.     exit $SHELL_LIB_USAGE_ERROR
  674.   fi
  675.  
  676.   _oldconffile="$1"
  677.   _newconffile="$2"
  678.  
  679.   remove_conffile_rollback "$_oldconffile"
  680.   if [ -f "$_newconffile" ]; then
  681.     rm "$_newconffile"
  682.   fi
  683. }
  684.  
  685. run () {
  686.   # syntax: run command [ argument ... ]
  687.   #
  688.   # Run specified command with optional arguments and report its exit status.
  689.   # Useful for commands whose exit status may be nonzero, but still acceptable,
  690.   # or commands whose failure is not fatal to us.
  691.   #
  692.   # NOTE: Do *not* use this function with db_get or db_metaget commands; in
  693.   # those cases the return value of the debconf command *must* be checked
  694.   # before the string returned by debconf is used for anything.
  695.  
  696.   #local retval
  697.  
  698.   # validate arguments
  699.   if [ $# -lt 1 ]; then
  700.     usage_error "run() called with wrong number of arguments; expected at" \
  701.                 "least 1, got $#"
  702.     exit $SHELL_LIB_USAGE_ERROR
  703.   fi
  704.  
  705.   "$@" || _retval=$?
  706.  
  707.   if [ ${_retval:-0} -ne 0 ]; then
  708.     observe "command \"$*\" exited with status $_retval"
  709.   fi
  710. }
  711.  
  712. register_x_lib_dir_with_ld_so () {
  713.   # syntax: register_x_lib_dir_with_ld_so
  714.   #
  715.   # Configure the dynamic loader ld.so to search /usr/X11R6/lib for shared
  716.   # libraries.
  717.   #
  718.   # Call this function from the postinst script of a package that places a
  719.   # shared library in /usr/X11R6/lib, before invoking ldconfig.
  720.  
  721.   #local dir ldsoconf
  722.  
  723.   _dir="/usr/X11R6/lib"
  724.   _ldsoconf="/etc/ld.so.conf"
  725.  
  726.   # is the line not already present?
  727.   if ! fgrep -qsx "$_dir" "$_ldsoconf"; then
  728.     observe "adding $_dir directory to $_ldsoconf"
  729.     echo "$_dir" >> "$_ldsoconf"
  730.   fi
  731. }
  732.  
  733. deregister_x_lib_dir_with_ld_so () {
  734.   # syntax: deregister_x_lib_dir_with_ld_so
  735.   #
  736.   # Configure dynamic loader ld.so to not search /usr/X11R6/lib for shared
  737.   # libraries, if and only if no shared libaries remain there.
  738.   #
  739.   # Call this function from the postrm script of a package that places a shared
  740.   # library in /usr/X11R6/lib, in the event "$1" is "remove", and before
  741.   # invoking ldconfig.
  742.  
  743.   #local dir ldsoconf fgrep_status cmp_status
  744.  
  745.   _dir="/usr/X11R6/lib"
  746.   _ldsoconf="/etc/ld.so.conf"
  747.  
  748.   # is the line present?
  749.   if fgrep -qsx "$_dir" "$_ldsoconf"; then
  750.     # are there any shared objects in the directory?
  751.     if [ "$(echo "$_dir"/lib*.so.*.*)" = "$_dir/lib*.so.*.*" ]; then
  752.       # glob expansion produced nothing, so no shared libraries are present
  753.       observe "removing $_dir directory from $_ldsoconf"
  754.       # rewrite the file (very carefully)
  755.       set +e
  756.       fgrep -svx "$_dir" "$_ldsoconf" > "$_ldsoconf.dpkg-tmp"
  757.       _fgrep_status=$?
  758.       set -e
  759.       case $_fgrep_status in
  760.         0|1) ;; # we don't actually care if any lines matched or not
  761.         *) die "error reading \"$_ldsoconf\"; fgrep exited with status" \
  762.           "$_fgrep_status" ;;
  763.       esac
  764.       set +e
  765.       cmp -s "$_ldsoconf.dpkg-tmp" "$_ldsoconf"
  766.       _cmp_status=$?
  767.       set -e
  768.       case $_cmp_status in
  769.         0) rm "$_ldsoconf.dpkg-tmp" ;; # files are identical
  770.         1) mv "$_ldsoconf.dpkg-tmp" "$_ldsoconf" ;; # files differ
  771.         *) die "error comparing \"$_ldsoconf.dpkg-tmp\" to \"$_ldsoconf\";" \
  772.           "cmp exited with status $_cmp_status" ;;
  773.       esac
  774.     fi
  775.   fi
  776. }
  777.  
  778. make_symlink_sane () {
  779.   # syntax: make_symlink_sane symlink target
  780.   #
  781.   # Ensure that the symbolic link symlink exists, and points to target.
  782.   #
  783.   # If symlink does not exist, create it and point it at target.
  784.   #
  785.   # If symlink exists but is not a symbolic link, back it up.
  786.   #
  787.   # If symlink exists, is a symbolic link, but points to the wrong location, fix
  788.   # it.
  789.   #
  790.   # If symlink exists, is a symbolic link, and already points to target, do
  791.   # nothing.
  792.   #
  793.   # This function wouldn't be needed if ln had an -I, --idempotent option.
  794.  
  795.   # Validate arguments.
  796.   if [ $# -ne 2 ]; then
  797.     usage_error "make_symlink_sane() called with wrong number of arguments;" \
  798.       "expected 2, got $#"
  799.     exit $SHELL_LIB_USAGE_ERROR
  800.   fi
  801.  
  802.   # We could just use the positional parameters as-is, but that makes things
  803.   # harder to follow.
  804.   #local symlink target
  805.  
  806.   _symlink="$1"
  807.   _target="$2"
  808.  
  809.   if [ -L "$_symlink" ] && [ "$(readlink "$_symlink")" = "$_target" ]; then
  810.       observe "link from $_symlink to $_target already exists"
  811.   else
  812.     observe "creating symbolic link from $_symlink to $_target"
  813.     mkdir -p "${_target%/*}" "${_symlink%/*}"
  814.     ln -s -b -S ".dpkg-old" "$_target" "$_symlink"
  815.   fi
  816. }
  817.  
  818. migrate_dir_to_symlink () {
  819.   # syntax: migrate_dir_to_symlink old_location new_location
  820.   #
  821.   # Per Debian Policy section 6.5.4, "A directory will never be replaced by a
  822.   # symbolic link to a directory or vice versa; instead, the existing state
  823.   # (symlink or not) will be left alone and dpkg will follow the symlink if
  824.   # there is one."
  825.   #
  826.   # We have to do it ourselves.
  827.   #
  828.   # This function moves the contents of old_location, a directory, into
  829.   # new_location, a directory, then makes old_location a symbolic link to
  830.   # new_location.
  831.   #
  832.   # old_location need not exist, but if it does, it must be a directory (or a
  833.   # symlink to a directory).  If it is not, it is backed up.  If new_location
  834.   # exists already and is not a directory, it is backed up.
  835.   #
  836.   # This function should be called from a package's preinst so that other
  837.   # packages unpacked after this one --- but before this package's postinst runs
  838.   # --- are unpacked into new_location even if their payloads contain
  839.   # old_location filespecs.
  840.  
  841.   # Validate arguments.
  842.   if [ $# -ne 2 ]; then
  843.     usage_error "migrate_dir_to_symlink() called with wrong number of"
  844.                 "arguments; expected 2, got $#"
  845.     exit $SHELL_LIB_USAGE_ERROR
  846.   fi
  847.  
  848.   # We could just use the positional parameters as-is, but that makes things
  849.   # harder to follow.
  850.   local _new _old
  851.  
  852.   _old="$1"
  853.   _new="$2"
  854.  
  855.   # Is old location a symlink?
  856.   if [ -L "$_old" ]; then
  857.     # Does it already point to new location?
  858.     if [ "$(readlink "$_old")" = "$_new" ]; then
  859.       # Nothing to do; migration has already been done.
  860.       observe "migration of $_old to $_new already done"
  861.       return 0
  862.     else
  863.       # Back it up.
  864.       warn "backing up symbolic link $_old as $_old.dpkg-old"
  865.       mv -b "$_old" "$_old.dpkg-old"
  866.     fi
  867.   fi
  868.  
  869.   # Does old location exist, but is not a directory?
  870.   if [ -e "$_old" ] && ! [ -d "$_old" ]; then
  871.       # Back it up.
  872.       warn "backing up non-directory $_old as $_old.dpkg-old"
  873.       mv -b "$_old" "$_old.dpkg-old"
  874.   fi
  875.  
  876.   observe "migrating $_old to $_new"
  877.  
  878.   # Is new location a symlink?
  879.   if [ -L "$_new" ]; then
  880.     # Does it point the wrong way, i.e., back to where we're migrating from?
  881.     if [ "$(readlink "$_new")" = "$_old" ]; then
  882.       # Get rid of it.
  883.       observe "removing symbolic link $_new which points to $_old"
  884.       rm "$_new"
  885.     else
  886.       # Back it up.
  887.       warn "backing up symbolic link $_new as $_new.dpkg-old"
  888.       mv -b "$_new" "$_new.dpkg-old"
  889.     fi
  890.   fi
  891.  
  892.   # Does new location exist, but is not a directory?
  893.   if [ -e "$_new" ] && ! [ -d "$_new" ]; then
  894.     warn "backing up non-directory $_new as $_new.dpkg-old"
  895.     mv -b "$_new" "$_new.dpkg-old"
  896.   fi
  897.  
  898.   # Create new directory if it does not yet exist.
  899.   if ! [ -e "$_new" ]; then
  900.     observe "creating $_new"
  901.     mkdir -p "$_new"
  902.   fi
  903.  
  904.   # Copy files in old location to new location.  Back up any filenames that
  905.   # already exist in the new location with the extension ".dpkg-old".
  906.   observe "copying files from $_old to $_new"
  907.   if ! (cd "$_old" && cp -a -b -S ".dpkg-old" . "$_new"); then
  908.     die "error(s) encountered while copying files from $_old to $_new"
  909.   fi
  910.  
  911.   # Remove files at old location.
  912.   observe "removing $_old"
  913.   rm -r "$_old"
  914.  
  915.   # Create symlink from old location to new location.
  916.   make_symlink_sane "$_old" "$_new"
  917. }
  918.  
  919. # vim:set ai et sw=2 ts=2 tw=80:
  920.  
  921. # GOBSTOPPER: The X Strike Force shell library ends here.
  922.  
  923. remove_conffile_commit /etc/X11/fonts/X11R7/100dpi/xfonts-100dpi.alias
  924.  
  925. # Automatically added by dh_installxfonts
  926. if which update-fonts-dir >/dev/null 2>&1; then
  927.     update-fonts-dir --x11r7-layout 100dpi;update-fonts-alias 100dpi
  928. fi
  929. # End automatically added section
  930.  
  931.  
  932. exit 0
  933.  
  934. # vim:ai:et:sts=2:sw=2:tw=0:
  935.